package commands;

import models.GameOfLife;

/**
 * Class used to modify the state of a Game of Life
 * 
 * @author wkillian
 */
public class ChangePropertyCommand implements Command {

	private GameOfLife game;
	private Object data;
	private String name;
	
	public ChangePropertyCommand(GameOfLife game, String propertyName, Object newValue) {
		this.game = game;
		this.data = newValue;
		this.name = propertyName;
	}
	
	@Override
	public void execute() {
		switch(this.name) {
		case "birthLow":
			this.game.setBirthLow((Integer)this.data);
			break;
		case "birthHigh":
			this.game.setBirthHigh((Integer)this.data);
			break;
		case "liveLow":
			this.game.setLiveLow((Integer)this.data);
			break;
		case "liveHigh":
			this.game.setLiveHigh((Integer)this.data);
			break;
		case "width":
			this.game.setWidth((Integer)this.data);
			break;
		case "height":
			this.game.setHeight((Integer)this.data);
			break;
		case "seed":
			this.game.setSeed((Long)this.data);
			break;
		}
	}

}
