package commands;

/**
 * Possible actions which can occur during a Game of Life simulation
 * 
 * @author wkillian
 *
 */
public enum SimulationAction {
	INITIALIZE,
	START,
	RESET,
	STEP;
	
	/**
	 * Returns a mapped SimulationAction given a string tag
	 * @param str tag for enumerated type
	 * @return the corresponding Simulation Action
	 * @throws IllegalArgumentException if no match was found for str
	 */
	public static SimulationAction fromString(String str) {
		switch (str) {
		case "initialize":
			return INITIALIZE;
		case "start":
			return START;
		case "reset":
			return RESET;
		case "step":
			return STEP;
		}
		throw new IllegalArgumentException("No match for " + str);
	}
}
