package commands;

import models.GameOfLife;

/**
 * Command which encapsulates a simulation action
 * @author wkillian
 *
 */
public class SimulationCommand implements Command {
	
	private GameOfLife game;
	private SimulationAction action;

	public SimulationCommand(GameOfLife game, SimulationAction action) {
		this.game = game;
		this.action = action;
	}

	@Override
	public void execute() {
		switch (action) {
		case START:
			game.start();
			break;
		case RESET:
			game.reset();
			break;
		case STEP:
			game.stepSimulation();
			break;
		case INITIALIZE:
			game.initialize();
			break;
		}
	}

}
