package controllers;

import commands.ChangePropertyCommand;
import commands.Command;
import commands.SimulationAction;
import commands.SimulationCommand;
import executors.CommandExecutor;
import models.GameOfLife;
import mvc.View;

public class GameOfLifeController extends mvc.Controller {

	public GameOfLifeController(GameOfLife model, View view) {
		super(model, view);
	}

	@Override
	protected void viewChange(String tag, Object data) {
		GameOfLife game = (GameOfLife) getModel();
		if (tag.equals("state")) {
			signal("state", game);
		} else {
			Command cmd = null;
			if (tag.equals("sim_command")) {
				cmd = new SimulationCommand(game, SimulationAction.fromString((String)data));
			} else {
				cmd = new ChangePropertyCommand(game, tag, data);
			}
			CommandExecutor.getInstance().submit(cmd);
		}
	}

	@Override
	protected void modelChange(String tag, Object data) {
	}

}
