package views;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;

import javax.swing.JComponent;
import javax.swing.UIManager;

/**
 * Drawable component for Java Swing
 * @author wkillian
 *
 */
public class World extends JComponent {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3000232599771787915L;

	private final Color NEW_COLOR = new Color(135, 206, 235);

	private boolean[][] data = null;

	public void setData(boolean[][] data) {
		this.data = data;
	}

	public void paintComponent(Graphics g) {
		if (data == null)
			return;
		final double X_SCALE = 1.0 * getWidth() / (data[0].length - 2);
		final double Y_SCALE = 1.0 * getHeight() / (data.length - 2);
		final double X_ORIGIN = 0.0;
		final double Y_ORIGIN = 0.0;
		super.paintComponents(g);

		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setBackground(UIManager.getColor("Panel.background"));
		g2.clearRect(0, 0, getWidth(), getHeight());
		g2.setColor(NEW_COLOR);
		double oldX = X_ORIGIN;
		double oldY = Y_ORIGIN;
		for (int r = 1; r < data.length; ++r) {
			double y = (r) * Y_SCALE;
			oldX = 0.0;
			for (int c = 1; c < data[r].length; ++c) {
				double x = (c) * X_SCALE;
				if (data[r][c]) {
					Rectangle rec = new Rectangle((int) (oldX), (int) (oldY), (int) Math.ceil(x - oldX),
							(int) Math.ceil(y - oldY));
					g2.fill(rec);
				}
				oldX = x;
			}
			oldY = y;
		}
	}
}
